function getSelectedValue(comboBoxName) {
    comboBox = document.getElementById(comboBoxName);
    comboBoxValue = comboBox[comboBox.selectedIndex].value;
    return comboBoxValue;
}

function setSelectedValue(comboBoxName, selectedValue) {
    comboBox = document.getElementById(comboBoxName);
    var len = comboBox.options.length;
    for (i = 0; i < len; i += 1) {
        if (comboBox.options[i].value == selectedValue) {
            comboBox.selectedIndex = i;
        }
    }
}

function systemLogConfig(thisObj, index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj, index);
        gatherHistoryObject(thisObj.id, index);
    }

    var body_xml = '<req:getSystemLogRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getSystemLogRequest>\n';

    var callURL = serverURL + "/" + "LoggingAdmin" ;
    send("getSystemLog", body_xml, "", callURL, "", false, systemLogConfigCallback);
}

function systemLogConfigCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("log.xsl", document.getElementById("divSystemConfiguration"));
}

function updateLoggerData() {

    var loggerName = getSelectedValue("loggerNameSettingCombo");
    var body_xml = '<req:getLoggerDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:loggerName>' + loggerName + '</req:loggerName>\n' +
                   ' </req:getLoggerDataRequest>\n';

    var callURL = serverURL + "/" + "LoggingAdmin" ;
    send("getLoggerData", body_xml, "", callURL, "", false, updateLoggerDataCallBack);
}

function updateLoggerDataCallBack() {
    if (!onError()) {
        return;
    }
    var logLevelCombBox = document.getElementById("loggerLogLevelSettingCombo");
    //alert(prettyPrintDOMNode(xhReq.responseXML));
    var logLevel = xhReq.responseXML.getElementsByTagName("level");
    var logLevelStr = logLevel[0].firstChild.nodeValue;
    var len = logLevelCombBox.options.length;
    for (i = 0; i < len; i += 1) {
        if (logLevelCombBox.options[i].value == logLevelStr) {
            logLevelCombBox.selectedIndex = i;
        }
    }

    var additivityElemet = xhReq.responseXML.getElementsByTagName("aditivity");
    var additivity = additivityElemet[0].firstChild.nodeValue;
    var additivityCoboBox = document.getElementById("loggerAdditiviySettingCombo");
    if (additivity == 'true') {
        additivityCoboBox.selectedIndex = 0;
    } else {
        additivityCoboBox.selectedIndex = 1;
    }

}

function updateAppenderData() {

    var appenderName = getSelectedValue("appeanderNameSettingCombo");
    var body_xml = '<req:getAppenderDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:appenderName>' + appenderName + '</req:appenderName>\n' +
                   ' </req:getAppenderDataRequest>\n';

    var callURL = serverURL + "/" + "LoggingAdmin" ;
    send("getAppenderData", body_xml, "", callURL, "", false, updateAppenderDataCallback);
}


/* updates the appender text in text box*/

function updateAppenderDataCallback() {

    if (!onError()) {
        return;
    }

    var patternInputBox = document.getElementById("appenderLogPatternField");
    var logPattern = xhReq.responseXML.getElementsByTagName("pattern");
    var logFile = xhReq.responseXML.getElementsByTagName("logFile");
    patternInputBox.value = logPattern[0].firstChild.nodeValue;

    // set the threshold
    var threshold = xhReq.responseXML.getElementsByTagName("threshold");
    setSelectedValue("appenderThresholdCombo", threshold[0].firstChild.nodeValue)

    var appenderLogFileDiv = document.getElementById("appenderLogFileDiv");
    var appenderSysLogDiv = document.getElementById("appenderSysLogDiv");

    var appenderIsFileAppenderElement = xhReq.responseXML.getElementsByTagName("isFileAppender");
    var appenderIsFileAppender = appenderIsFileAppenderElement[0].firstChild.nodeValue;

    if (appenderIsFileAppender == 'true') {
        appenderLogFileDiv.style.display = "inline";
        var logFileInputBox = document.getElementById("appenderLogFile");
        logFileInputBox.value = logFile[0].firstChild.nodeValue;
    } else {
        appenderLogFileDiv.style.display = "none";
    }

    var appenderIsSysLogAppenderElement = xhReq.responseXML.getElementsByTagName("isSysLogAppender");
    var appenderIsSysLogAppender = appenderIsSysLogAppenderElement[0].firstChild.nodeValue;

    if (appenderIsSysLogAppender == 'true') {
        appenderSysLogDiv.style.display = "inline";
        // set sysLog host
        var sysLogHost = xhReq.responseXML.getElementsByTagName("sysLogHost");
        var sysLogHostInputBox = document.getElementById("appenderSysLogHost");
        sysLogHostInputBox.value = sysLogHost[0].firstChild.nodeValue;

        // set Facility
        var facility = xhReq.responseXML.getElementsByTagName("facility");
        setSelectedValue("appenderFacilitySettingCombo", facility[0].firstChild.nodeValue)
    } else {
        appenderSysLogDiv.style.display = "none";
    }
}

function storeAppenderData() {

    var appenderName = getSelectedValue("appeanderNameSettingCombo");
    var appenderPattern = document.getElementById("appenderLogPatternField").value;
    var threshold = getSelectedValue("appenderThresholdCombo");

    var logFileInputBox = document.getElementById("appenderLogFile");
    var sysLogHostInputBox = document.getElementById("appenderSysLogHost");
    var facility = getSelectedValue("appenderFacilitySettingCombo");

    var body_xml;
    var callURL = serverURL + "/" + "LoggingAdmin" ;

    if(appenderName == "WSO2WSAS_LOGFILE" && trim(logFileInputBox.value) == ""){
        alertWarning("Please specify a valid log file.");
        return;
    }

    body_xml = '<req:updateAllAppenderDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
               ' <req:appenderName>' + appenderName + '</req:appenderName>\n' +
               ' <req:appenderPattern>' + appenderPattern + '</req:appenderPattern>\n' +
               ' <req:threshold>' + threshold + '</req:threshold>\n' +
               ' <req:logFileName>' + logFileInputBox.value + '</req:logFileName>\n' +
               ' <req:sysLogHost>' + sysLogHostInputBox.value + '</req:sysLogHost>\n' +
               ' <req:facility>' + facility + '</req:facility>\n' +
               ' </req:updateAllAppenderDataRequest>\n';

    send("updateAllAppenderData", body_xml, "", callURL, "", false, storeAppenderDataCallBack);

}

function storeAppenderDataCallBack() {
    if (!onError()) {
        return;
    }
    alertMessage("Successfully updated appender data.")
}

function storeLoggerData() {

    var loggerName = getSelectedValue("loggerNameSettingCombo");
    var loggerLevel = getSelectedValue("loggerLogLevelSettingCombo");
    var loggerAditivity = getSelectedValue("loggerAdditiviySettingCombo");

    var callURL = serverURL + "/" + "LoggingAdmin" ;
    var body_xml = '<req:updateLoggerDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:loggerName>' + loggerName + '</req:loggerName>\n' +
                   ' <req:loggerLevel>' + loggerLevel + '</req:loggerLevel>\n' +
                   ' <req:additivity>' + loggerAditivity + '</req:additivity>\n' +
                   ' </req:updateLoggerDataRequest>\n';

    send("updateLoggerData", body_xml, "", callURL, "", false, storeLoggerDataCallBack);
}

function storeLoggerDataCallBack() {
    if (!onError()) {
        return;
    }
    alertMessage("Successfully updated logger data.");
}

/* Will update the log level, patern and file on the server globally. */
function setGlobalLogData() {
    var change = confirm("Do you really want to change the global Log4J configuration?");
    if (change == true) {
        var logLevel = getSelectedValue("globalLogLevelSettingCombo");
        var logPattern = document.getElementById('globalLogPatternField').value;

        var body_xml = '<req:updateSystemLogRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:logLevel>' + logLevel + '</req:logLevel>\n' +
                       ' <req:logPattern>' + logPattern + '</req:logPattern>\n' +
                       ' </req:updateSystemLogRequest>\n';

        var callURL = serverURL + "/" + "LoggingAdmin" ;
        send("updateSystemLog",
                body_xml,
                "",
                callURL,
                document.getElementById("divSystemConfiguration"),
                false,
                setGlobalLogConfigurationCallBack(logLevel, logPattern));
    }
}

function setGlobalLogConfigurationCallBack(logLevel, logPattern) {
    if (!onError()) {
        return;
    }
    // update the logger level and appender pattern
    var patternInputBox = document.getElementById("appenderLogPatternField");
    patternInputBox.value = logPattern;

    var logLevelCombBox = document.getElementById("loggerLogLevelSettingCombo");
    var len = logLevelCombBox.options.length;
    for (i = 0; i < len; i += 1) {
        if (trim(logLevelCombBox.options[i].value) == trim(logLevel)) {
            logLevelCombBox.selectedIndex = i;
        }
    }

    var logAppenderThreshouldCombBox = document.getElementById("appenderThresholdCombo");
    len = logAppenderThreshouldCombBox.options.length;
    for (i = 0; i < len; i += 1) {
        if (trim(logAppenderThreshouldCombBox.options[i].value) == trim(logLevel)) {
            logAppenderThreshouldCombBox.selectedIndex = i;
        }
    }

    alertMessage("Global logging configuration successfully updated.");
}

function restoreDefaults() {
    var body_xml = '<req:restoreDefaults xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '</req:restoreDefaults>\n';

    var callURL = serverURL + "/" + "LoggingAdmin" ;
    send("restoreDefaults", body_xml, "", callURL, "", false, restoreDefaultsCallback);

}

function restoreDefaultsCallback() {
    if (!onError()) {
        return;
    }
    alertMessage("Successfully restored default logging configuration.");
    systemLogConfig();

}
