/*
log.js contains scripts need to handle log information.
*/

// Adding some colors to the logs
var TRACE_color = "#FFFFFFFF";
var DEBUG_color = "#C6FFFF";
var INFO_color = "#B4F3FF";
var WARN_color = "#FEE3A1";
var ERROR_color = "#F7B761";
var FATAL_color = "#EA8823";

var showDivViewLogsInterval = 0;
var showDivViewLogs = false;

var VIWE_LOGS_REFRESHING_TIME= 10000; //Default refreshing time is every 10 Sec

function showViewLogs(thisObj,index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }
    //initial firing
    viewLogs();

    /* Refreshing of logs have been removed due request by users.
    if (showDivViewLogsInterval == 0) {
        showDivViewLogsInterval = setInterval('viewLogs()',VIWE_LOGS_REFRESHING_TIME);
    }*/


}

function viewLogs() {

    var body_xml = '<ns1:getLogsRequest xmlns:ns1="http://logging.service.admin.wsas.wso2.org">' +
                   '<amount>100</amount>' +
                   '<layoutPattern></layoutPattern>' +
                   '</ns1:getLogsRequest>';

    var callURL = serverURL + "/" + LOGGING_SERVICE_STRING + "/" + "getLogs";

    if (document.getElementById("viewLogs").style.display == 'none' &&
        showDivViewLogs) {
        showDivViewLogs = false;
        clearInterval(showDivViewLogsInterval);
        showDivViewLogsInterval = 0;
        // this is to counter if focus to divStatistics is vanished.
        return false;

    }


    send("getLogs", body_xml, "", callURL, "", false, viewLogsCallback);

}

function viewLogsCallback() {
    if (!onError()) {
        return;
    }
    var objDiv = document.getElementById("viewLogs");
    var data = getBody(xhReq.responseXML);
    var strHTML = '<h2>System Logs</h2>' +
                  '<div id="formset"><form><fieldset>' +
                  "<div style='overflow: auto; height: 480px'>"; //textarea cols="90" rows="30"
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;

	var str_line_type = "";
	var str_line_color = "";
    for (count = 0; count < len; count++) {
		str_line_type = rets[count].firstChild.nodeValue;
		str_line_type = str_line_type.substring(0, 6);
		str_line_color = getLogLineColor(str_line_type);
        strHTML += "<p style='background-color: " + str_line_color + ";border:1px solid #D0D0D0;'>"+ rets[count].firstChild.nodeValue + "</p>";
    }
    strHTML += "</div></fieldset></form></div>"
    objDiv.innerHTML = strHTML;
    showOnlyOneMain(objDiv);

    showDivViewLogs = true;

}

function getLogLineColor(str_line_type){
	if (str_line_type == "TRACE ") return TRACE_color;
	if (str_line_type == "DEBUG ") return DEBUG_color;
	if (str_line_type == " INFO ") return INFO_color;
	if (str_line_type == " WARN ") return WARN_color;
	if (str_line_type == "ERROR ") return ERROR_color;
	if (str_line_type == "FATAL ") return FATAL_color;
}

