var lastUsedModuleId = "";
var lastUsedModuleVersion = "";
var moduleXSLTFileName = "modules.xsl";
var moduleConfigureXSLTFileName = "configure_module.xsl";

function engageModuleForSystem(moduleId, moduleVersion) {
    var engage= confirm("Do you really want to globally engage the "+ moduleId +" module?");
    if (engage == true) {
        var body_xml = '<ns1:engageModuleForSystem xmlns:ns1="http://org.apache.axis2/xsd">' +
                       '<ns1:moduleid>' + moduleId + '</ns1:moduleid>' +
                       '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                       '</ns1:engageModuleForSystem>';

        var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
        send("engageModuleForSystem", body_xml, "", callURL, "", false, engageModuleForSystemCallback);
    }
}

function engageModuleForSystemCallback(){
	if (!onError()) {
		return;
	}
    var data = getBody(xhReq.responseXML);
    var text = data.getElementsByTagName('return')[0];

    alertMessage(text.firstChild.nodeValue);
	listModules();
}

function disengageModuleForSystem(moduleId, moduleVersion){

    var addressingRegx = /^addressing/i;
    if (addressingRegx.test(moduleId)) {
        alertWarning("Cannot disengage the addressing module. It is required by the Management Console.");
        return false;
    }

    var disengage= confirm("Do you really want to globally disengage the "+ moduleId +" module?");
    if (disengage == true) {
        var body_xml = '<ns1:disengageModuleFromSystem xmlns:ns1="http://org.apache.axis2/xsd">' +
                       '<ns1:moduleid>' + moduleId + '</ns1:moduleid>' +
                       '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                       '</ns1:disengageModuleFromSystem>';

        var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
        send("disengageModuleFromSystem", body_xml, "", callURL, "", false, disengageModuleForSystemCallback);
    }
}

function disengageModuleForSystemCallback(){
	if (!onError()) {
		return;
	}
	alertMessage("Module was globally disengaged successfuly.");
	listModules();
}


function getLastUsedModuleId() {
    return lastUsedModuleId;
}

function getLastUsedModuleVersion() {
    return lastUsedModuleVersion;
}

/* Will get and display the parameters for the given module id and version. */
function getModuleParameters(moduleId, moduleVersion) {
    lastUsedModuleId = moduleId;
    lastUsedModuleVersion = moduleVersion;
    //hand make the request
    var body_xml = '<ns1:getModuleParametersRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:moduleid>' + moduleId + '</ns1:moduleid>' +
                   '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                   '</ns1:getModuleParametersRequest>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("getModuleParameters", body_xml, moduleXSLTFileName, callURL, document.getElementById("divGetModuleParameters"), false);

}


/* List modules - Will create an html object for a list of modules and will attach it to divListModules */
function listModules(thisObj,index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }
    
    var body_xml = '<ns1:listModules  xmlns:ns1="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING + "/" + "listModules";
//    send("listModules", body_xml, moduleXSLTFileName, callURL, document.getElementById("divListModules"), false);
    send("listModules", body_xml, "", callURL, "", false, listModulesCallback);
}

function listModulesCallback() {
    if (!onError()) {
        return;
    }
	callbackhelper(moduleXSLTFileName, document.getElementById("divListModules"));
    // Observing the globally engage modules
    listGloballyEngageModulesForObservation();
}

function getModuleInfo(moduleId, moduleVersion) {

    var body_xml = '<ns1:getModuleInfo  xmlns:ns1="http://org.apache.axis2/xsd">\n' +
                   '<ns1:moduleId>' + moduleId + '</ns1:moduleId>\n' +
                   '<ns1:moduleVersion>' + moduleVersion + '</ns1:moduleVersion>\n' +
                   '</ns1:getModuleInfo>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("getModuleInfo", body_xml, "", callURL, "", false, getModuleInfoCallback);
}

function getModuleInfoCallback() {
    if (!onError()) {
        return;
    }
	callbackhelper("configure_module.xsl", document.getElementById("divConfigureModule"));
}

/* This will iterate through the list of parameter names and parameter values and calls the server
	to update that parameter with the new values. */
	var cur_module_number = 0;
	var global_arrayOfNames = null;
	var global_arrayOfValues = null;
function processModuleConfigUpdate(arrayOfNames, arrayOfValues) {

    processMultipleModuleConfigEntry(getLastUsedModuleId(),getLastUsedModuleVersion(),arrayOfNames,arrayOfValues);
}

/* This is called by processModuleConfigUpdate for each name value pair. This will do the actual server
	call to update the parameter in question */

function processMultipleModuleConfigEntry(moduleid, moduleVersion,parameterNamesObj,parameterValueObj) {
    var paramElements = '';
    for (var i = 0 ; i < parameterNamesObj.length; i++) {
        paramElements += '<parameter locked="false" name="' + parameterNamesObj[i] + '"><![CDATA[' + parameterValueObj[i] +']]></parameter>\n';
    }

    var body_xml = '<ns1:setModuleParameters xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:moduleid>' + moduleid + '</ns1:moduleid>' +
                   '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                   paramElements +
                   '</ns1:setModuleParameters>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("setModuleParameters", body_xml, "", callURL, "", false, processMultipleModuleConfigEntryCallback);

}

function processMultipleModuleConfigEntryCallback() {
    if (!onError()) {
        return;
    }

    alertMessage("Module parameters were successfully updated.");

    getModuleParametersForConfig(getLastUsedModuleId(),getLastUsedModuleVersion());
}

function processSingleModuleConfigEntry(moduleid, moduleVersion, itemName, itemValue, callback) {

    if (!parseParameterName(itemName)) {
        alertMessage("Parameter name contains an invalid character");
        return false;
    }

    var body_xml = '<ns1:setModuleParameterRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:moduleid>' + moduleid + '</ns1:moduleid>' +
                   '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                   '<parameter locked="false" name="' + itemName + '"><![CDATA[' + itemValue + ']]></parameter>' +
                   '</ns1:setModuleParameterRequest>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("setModuleParameter", body_xml, "", callURL, "", false, callback);
}

/* Used to show the value passed to the function to the user. This is tipicaly used to
	display whether an update was successful, etc. */
function updateModuleInfoDisplay(message) {
    document.getElementById('moduleConfigUpdate').innerHTML = message;
}


//add a new module parameter
function addModuleParameter() {
    var newParam = getUserInput();
    if (newParam != null) {
        processSingleModuleConfigEntry(
                getLastUsedModuleId(),
                getLastUsedModuleVersion(),
                newParam[0],
                newParam[1], getModuleParametersForConfig);
    }
}

/* Will get the parameters for the given module. Will display the returned data in
	divGetModuleParametersForConfig. */
function getModuleParametersForConfig(moduleId, moduleVersion) {
    //set the last Used module Id and version.
	if (moduleId == null){
		if (!onError()) {
			return;
		}
		moduleId = lastUsedModuleId;
	} else {
		lastUsedModuleId = moduleId;
	}
	if (moduleVersion == null){
		moduleVersion = lastUsedModuleVersion;
	} else {
		lastUsedModuleVersion = moduleVersion;
	}

    var body_xml = '<ns1:getModuleParametersRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:moduleid>' + moduleId + '</ns1:moduleid>' +
                   '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                   '</ns1:getModuleParametersRequest>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("getModuleParameters",
            body_xml,"",callURL, "", false,getModuleParametersForConfigCallback);

}

function getModuleParametersForConfigCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("configure_module_parameters.xsl",document.getElementById("divGetModuleParametersForConfig"));
    showconfigureModuleHeader(document.getElementById('configureModuleHeader'));
}

/* This will remove a module from the system */
function removeModule(moduleId, moduleVersion) {
    var delete_module= confirm("Do you really want to remove this module from the system?");
    if (delete_module == true) {
        var body_xml = '<ns1:removeModule xmlns:ns1="http://org.apache.axis2/xsd">' +
                       '<ns1:moduleid>' + moduleId + '</ns1:moduleid>' +
                       '<ns1:moduleversion>' + moduleVersion + '</ns1:moduleversion>' +
                       '</ns1:removeModule>';

        var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
        send("removeModule", body_xml, "", callURL, "", false, removeModuleCallback);
    }
}

function removeModuleCallback(){
	if (!onError()) {
		return;
	}
	listModules();
	stopWaitAnimation();
    var restart= confirm("Module was removed successfuly from the repository." +
                        "\n The server needs to be restarted for this to take effect." +
                        "\n Restart now?");
    if (restart) {
        restartServer();
    }
}


function listGloballyEngageModulesForObservation() {
    body_xml = '<req:listGloballyEngagesModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
               ' </req:listGloballyEngagesModulesRequest>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("listGloballyEngagesModules", body_xml, "", callURL, "", false, listGloballyEngageModulesForObservationCallback);

}

function listGloballyEngageModulesForObservationCallback() {
    if (!onError()) {
        return;
    }
	callbackhelper("list_engaged_modules_per_service.xsl", document.getElementById("listGloballyEngageModulesForObserve"), true);
//    showgetModuleParameterHeader(document.getElementById('getModuleParameterHeader'));
}

////////////////////////////////////////////////////////////////////////////////
//                            <wsp:Policy> 				      //
////////////////////////////////////////////////////////////////////////////////


function getModulePolicies(moduleId, moduleVersion) {

    lastUsedModuleId = moduleId;
    lastUsedModuleVersion = moduleVersion;

    var body_xml = '<ns1:getPoliciesRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:moduleId>' + moduleId + '</ns1:moduleId>' +
                   '<ns1:moduleVersion>' + moduleVersion + '</ns1:moduleVersion>' +
                   '</ns1:getPoliciesRequest>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;

    send("getPolicies", body_xml, "", callURL, "", false, getModulePoliciesCallback);
}

function getModulePoliciesCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("module_policies_edit.xsl", document.getElementById("divModules"));
    showlistPolicyModuleHeader(document.getElementById('modulePoliciesEditHeader'));
    var data = getBody(xhReq.responseXML);
    var children = data.getElementsByTagName('return');
    var textBox;
    for (i = 0; i < children.length; i++) {
        eval("textBox=document.getElementById('" + (i + 1) + "_module_policy_text_')");
//        textBox.value =
//        (new XMLSerializer().serializeToString(children[i].firstChild.firstChild));
          textBox.value = xmlSerializerToString(children[i].firstChild.firstChild);
    }
}

function updateModulePolicy(module_id, module_version, policy_value) {
    var body_xml = '<my:setPolicy xmlns:my="http://org.apache.axis2/xsd">' +
                   '<my:moduleId>' + module_id + '</my:moduleId>' +
                   '<my:moduleVersion>' + module_version + '</my:moduleVersion>' +
                   '<my:policyString><![CDATA[' + policy_value + ']]></my:policyString>' +
                   '</my:setPolicy>';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING;
    send("setPolicy", body_xml, "", callURL, "", false, updateModulePolicyCallback);
}

function updateModulePolicyCallback() {

    if (!onError()) {
        return;
    }

    var restart= confirm("Module policy successfully updated." +
                        "\n The server needs to be restarted for the modified policy to take effect." +
                        "\n Restart now?");
    if (restart) {
        restartServer();
    }
}
