/*
Service Group manipulation
*/

var moduleServiceGroupName;

function showServiceGroupInfo(serviceGroupName) {
    /* stopping the refreshing first when the system running in very latent systems */
    stoppingRefreshingMethodsHook();

    moduleServiceGroupName = serviceGroupName;
    var objDiv = document.getElementById('divshowServiceGroupInfo');

    var strInnerHtml = "<h4><a href='#' onClick='javascript:showServiceInitializer(); return false;'>Services</a>&nbsp;&gt;&nbsp;" +
                       serviceGroupName + "&nbsp;Service Group</h4>" +
                       "<h2>Service Group Management &nbsp;[" + serviceGroupName + "]</h2>" +
                       "<fieldset style='border: 0px;'><div>" +
                       "<a id='operations_link' href='#' onclick='javascript:getServiceGroupSpecificParametersForConfig(\""+serviceGroupName+"\");return false;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Manage Service Group Parameters</a>" +
                       "</div><div>"+
                       "<a id='module_view_link' href='#' onclick='javascript:engageModulePerServiceGroup(\""+serviceGroupName+"\");return false;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Manage Module Engagements</a>" +
                       "</div></fieldset>";

    objDiv.innerHTML = strInnerHtml;
    showOnlyOneMain(objDiv);
}

function getServiceGroupSpecificParametersForConfig(serviceGroupId) {
    if (serviceGroupId == null) { // this happend only when call made within to this service
        if (!onError()) {
            return;
        }
        serviceGroupId = moduleServiceGroupName;

    } else {
        moduleServiceGroupName = serviceGroupId;
    }
    var body_xml = '<req:getDeclaredServiceGroupParametersRequest xmlns:req="http://org.apache.axis2/xsd">' +
                   '<serviceGroupId>' + serviceGroupId + '</serviceGroupId>' +
                   '</req:getDeclaredServiceGroupParametersRequest>';

    var callURL = serverURL + "/" + SERVICE_GROUP_ADMIN_STRING + "/" ;
    send("getDeclaredServiceGroupParameters", body_xml, "", callURL, "", false, getServiceGroupSpecificParametersForConfigCallback);
}

function getServiceGroupSpecificParametersForConfigCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("list_service_group_params_edit.xsl", document.getElementById("divGetServiceGroupSpecficParameters"));
    showlistServiceGroupParamHeader(document.getElementById('listServiceGroupParamEditHeader'));

}

function addServiceGroupParameter() {
    var newParam = getUserInput();
    if (newParam != null) {
        processSingleOperationParameterConfigEntrySG(moduleServiceGroupName,
                newParam[0],
                newParam[1], getServiceGroupSpecificParametersForConfig);
    }

}

function processMultipleOperationParameterConfigEntrySG(serviceGroupName, parameterNamesObj,
                                                      parameterValueObj){
    // the length of  parameterNamesObj and  parameterValueObj are same

    var paramElements = '';
    for (var i = 0 ; i < parameterNamesObj.length; i++) {
        paramElements += '<parameter locked="false" name="' + parameterNamesObj[i] + '"><![CDATA[' + parameterValueObj[i] +']]></parameter>\n';
    }

    var body_xml = '<ns1:setServiceGroupParameters xmlns:ns1="http://org.apache.axis2/xsd">\n' +
                   '<serviceGroupId>' + serviceGroupName + '</serviceGroupId>\n' +
                   paramElements +
                   '</ns1:setServiceGroupParameters>';

    var callURL = serverURL + "/" + SERVICE_GROUP_ADMIN_STRING;
    send("setServiceGroupParameters", body_xml, "", callURL, "", false, processMultipleOperationParameterConfigEntrySGCallback);


}

function processMultipleOperationParameterConfigEntrySGCallback() {
    if (!onError()) {
        return;
    }

    alertMessage("Service group parameters were successfully updated.");

    getServiceGroupSpecificParametersForConfig(moduleServiceGroupName);



}
function processSingleOperationParameterConfigEntrySG(serviceGroupName, parameterName,
                                                      parameterValue, callback) {

    if (!parseParameterName(parameterName)) {
        alertMessage("Parameter name contains an invalid character");
        return false;
    }


    var body_xml = '<ns1:setServiceGroupParameterRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<serviceGroupId>' + serviceGroupName + '</serviceGroupId>' +
                   '<parameter locked="false" name="' + parameterName + '"><![CDATA[' + parameterValue +
                   ']]></parameter>' +
                   '</ns1:setServiceGroupParameterRequest>';

    var callURL = serverURL + "/" + SERVICE_GROUP_ADMIN_STRING;
    //update the information in operation display page
    updateServiceGroupOperationInfoDisplay("Sending value for " + parameterName);
    send("setServiceGroupParameter", body_xml, "", callURL, "", false, callback);

}
/*
arrayOfName and arrayOfvalues have one to one
*/
function processServiceGroupParameterConfigUpdate(arrayOfNames, arrayOfValues) {

    processMultipleOperationParameterConfigEntrySG(
            moduleServiceGroupName,
            arrayOfNames,
            arrayOfValues);
}

function updateServiceGroupOperationInfoDisplay(message) {
    document.getElementById('serviceGroupParamUpdate').innerHTML = message;
}

// Module Management


function engageModulePerServiceGroup(serviceGroupId) {
    moduleServiceGroupName = serviceGroupId;

    var objDiv = document.getElementById("divEngageModuleForServiceGroup");
    var strInnerHtml = "<h4><a href='#' onClick='javascript:showServiceInitializer(); return false;'>Services</a>&nbsp;&gt;&nbsp;<a href='#' onClick='javascript:showServiceGroupInfo(\"" + serviceGroupId + "\"); return false;'>" + "ServiceGroup[" +serviceGroupId +"]"+ "</a>&nbsp;&gt;&nbsp;Engage Modules</h4>" +
                  "<fieldset style='border: none;'>" +
                  "<div id='formset'>" +
                  "<form>" +
                  "<fieldset>" +
                  "<legend>Engage module to Service Group <font color='blue'>" + serviceGroupId + "</font></legend>" +
                  "<div><label>Module</label><span id='engageModulePerServiceGroupCombo'></span></div>" +
                  "<div class='buttonrow'><input type='button' onclick='javascript:engageModulePerServiceGroupExec(\"" + serviceGroupId + "\", document.getElementById(\"cmbEngageModulePerServiceGroupCombo\").value);' value='Engage'/></div>" +
                  "</fieldset>" +
                  "</form>" +
                  "<div id='modulesEngageOnServiceGroup' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='globleModulesOnServiceGroup' style='display:inline; position: relative; top: 20px;'></div>" +
                  "</div>" +
                  "</fieldset>";


    objDiv.innerHTML = strInnerHtml;
    showOnlyOneMain(objDiv);

    //globally engage

    body_xml = '<req:listGloballyEngagesModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
               ' </req:listGloballyEngagesModulesRequest>\n';
    callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("listGloballyEngagesModules", body_xml, "", callURL, "", false, globallyEngageModulesOnServiceGroupCallback);

}

function globallyEngageModulesOnServiceGroupCallback() {
    if (!onError()) {
        return;
    }

    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("globleModulesOnServiceGroup");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    //listing for  modulesEngageOnServiceGroup
    var body_xml = '<req:listServiceGroupModulesRequest xmlns:req="http://org.apache.axis2/xsd">' +
                   ' <serviceGroupId>' + moduleServiceGroupName + '</serviceGroupId>' +
                   ' </req:listServiceGroupModulesRequest>';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("listServiceGroupModules", body_xml, "", callURL, "", false, listServiceGroupModulesCallback);

}

function listServiceGroupModulesCallback() {
    if (!onError()) {
        return;
    }
    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("modulesEngageOnServiceGroup");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    //listing the engageModulePerServiceGroupCombo

    getGlobalModuleComboServiceGroup(document.getElementById("engageModulePerServiceGroupCombo"), "cmbEngageModulePerServiceGroupCombo");


}


function getGlobalModuleComboServiceGroup(cmbSpan, cmbName) {
    moduleSpanToUse = cmbSpan;
    moduleComboName = cmbName;
//    alert("Global module getting function called");

    var body_xml = '<ns1:listModules  xmlns:ns1="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING + "/" + "listModules";
    send("listModules", body_xml, "", callURL, "", false, getGlobalModuleComboServiceGroupCallback);

}

function getGlobalModuleComboServiceGroupCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

//    alert("XSL = " + (new XMLSerializer()).serializeToString(data));

    var strHTML = "<select id='" + moduleComboName + "'>";
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    var moduleVersion;
    for (count = 0; count < len; count++) {
    	if (rets[count].getElementsByTagName("moduleversion")[0].firstChild != null){
    		moduleVersion = rets[count].getElementsByTagName("moduleversion")[0].firstChild.nodeValue;
    	} else {
    		moduleVersion = "";
    	}
        displayModuleVersion = (moduleVersion == "" ? "" : ("-"+moduleVersion));
        strHTML += "<option value='" + rets[count].getElementsByTagName("moduleid")[0].firstChild.nodeValue + '||' + moduleVersion + "'>" + rets[count].getElementsByTagName("modulename")[0].firstChild.nodeValue +displayModuleVersion+ "</option>\n";
    }
    strHTML += "</select>"

    moduleSpanToUse.innerHTML = strHTML;

}

function engageModulePerServiceGroupExec(serviceGroupId, moduleName) {
    var moduleVersion = moduleName.substring(moduleName.indexOf('||') + 2, moduleName.length);
    moduleServiceGroupName = serviceGroupId;
    setModuleVersion = moduleVersion;
    moduleName = moduleName.substring(0, moduleName.indexOf('||'));
    //	alert("engageModulePerServiceExec Called with serviceName = " +serviceName + " || moduleName = " + moduleName + " ||| moduleVersion = " + moduleVersion);
    setModuleName = moduleName;

    var body_xml = '<req:engageModuleForServiceGroupRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <moduleId>' + moduleName + '</moduleId>\n' +
                   ' <moduleVersion>' + moduleVersion + '</moduleVersion>\n' +
                   ' <serviceGroupId>' + serviceGroupId + '</serviceGroupId>\n' +
                   ' </req:engageModuleForServiceGroupRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("engageModuleForServiceGroup", body_xml, "", callURL, "", false, engageModulePerServiceGroupExecCallback);

}

function engageModulePerServiceGroupExecCallback() {
    if (!onError()) {
        return;
    }

    var data = getBody(xhReq.responseXML);
    var text = data.getElementsByTagName('return')[0];

    alertMessage(text.firstChild.nodeValue);

    setTimeout(function() {engageModulePerServiceGroup(moduleServiceGroupName);},1000);

}

function disengageModuelfromServiceGroupExec(moduleName) {
    // gettting all the values from engageModulePerOperationExec
    var moduleVersion;
    var moduleNameid;
    if (moduleName.indexOf('-') > 0) {
	    moduleVersion = moduleName.substring(moduleName.indexOf('-') + 1, moduleName.length);
    	moduleNameid = moduleName.substring(0, moduleName.indexOf('-'));
    } else {
    	moduleVersion = "";
    	moduleNameid = moduleName;
    }

    var body_xml = '<req:disengageModuleFromServiceGroupRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<moduleId>' + moduleNameid + '</moduleId>\n' +
                   '<moduleVersion>' + moduleVersion + '</moduleVersion>\n' +
                   '<serviceGroupId>' + moduleServiceGroupName + '</serviceGroupId>\n' +
                   '</req:disengageModuleFromServiceGroupRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("disengageModuleFromServiceGroup", body_xml, "", callURL, "", false, disengageModuelfromServiceGroupExecCallback);

}

function disengageModuelfromServiceGroupExecCallback() {
    if (!onError()) {
        return;
    }
    alertMessage("Module was disengaged from service successfully.");
    setTimeout(function() {engageModulePerServiceGroup(moduleServiceGroupName);},1000);

}
