/*
tracer.js handles script related to tracing SOAP messages at server side.
*/


var txtAreaSendBoolean = false;
var txtAreaReceiveBoolean = false;
var m_updateDiv;

/* For Monitoring Status */
var monitoringStatus = 'OFF';

function loadMonitorSetting() {
    var body_xml = '<req:getMessageMonitoringStatusRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getMessageMonitoringStatusRequest>\n';

    var callURL = serverURL + "/" + "TracerAdmin" + "/" ;
    send("getMessageMonitoringStatus", body_xml, "", callURL, "", false, loadMonitorSettingCallback);
}

function loadMonitorSettingCallback() {

    if (!onError()) {
        return;
    }
//    callbackhelper("log_monitor.xsl", document.getElementById("divSystemConfiguration"));
    var comboToLoad = document.getElementById('monitorSettingCombo');
    var data = getBody(xhReq.responseXML);
    var rets = data.getElementsByTagName("return");

    var topOpt = new Option(rets[0].firstChild.nodeValue);
    topOpt.value = rets[0].firstChild.nodeValue;
    comboToLoad.options[0] = topOpt;
    monitoringStatus = rets[0].firstChild.nodeValue;
    if (rets[0].firstChild.nodeValue == 'ON') {
        var opt = new Option('OFF');
        opt.value = 'OFF';
        comboToLoad.options[1] = opt;
    } else {
        var opt = new Option('ON');
        opt.value = 'ON';
        comboToLoad.options[1] = opt;
    }

    //Load Tracer stuff.
    loadTracerListComboBox(document.getElementById('tracerSelectBox'));
}

function setMonitoring(obj) {


    var value = obj[obj.selectedIndex].value;

    var body_xml = '<req:setTracingRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:onOff>' + value + '</req:onOff>\n' +
                   ' </req:setTracingRequest>\n';

    var callURL = serverURL + "/" + "TracerAdmin" ;
    monitoringStatus = value;
    send("setTracing", body_xml, "", callURL,
            document.getElementById("divSystemConfiguration"), false, setMonitoringCallback);
}


function setMonitoringCallback() {
    if (!onError()) {
        return;
    }
    cursorWait();
    setTimeout("showsetMonitoringCompleteMsg()", 1000);
}

function showsetMonitoringCompleteMsg() {
    cursorClear();
    if (monitoringStatus == 'ON') {
        alertMessage("SOAP tracing turned on.<br/><br/>" +
           "<b>WARNING:</b> Turning this ON will have a performance hit, " +
           "since all SOAP messages will be always completely built " +
           "(i.e. deferred building will not be done) " +
           "and stored in the database by WSO2 WSAS hence this option" +
           " should be used with caution.");
    }else{
        alertMessage("SOAP message monitoring turned OFF.");
    }
    clearTracer();
}

function viewTracer(thisObj,index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }

    var body_xml = '<req:getLastMessagesRequest xmlns:req="http://tracer.service.admin.wsas.wso2.org">\n' +
                   '<messages>1</messages>\n' +
                   '</req:getLastMessagesRequest>\n';

    var callURL = serverURL + "/" + "TracerService" ;
    send("getLastMessages", body_xml, "", callURL, "", false, viewTracerCallback);
}

function viewTracerCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("tracer.xsl", document.getElementById("divTracer"));
    // setting monitor setting
    loadMonitorSetting();
//    loadTracerListComboBox(document.getElementById('tracerSelectBox'));
}


// this is a call through tracer.xslt
function traceMessage(valueObject) {
//    var tracerName = valueObject.value;

    var tracerName = valueObject[valueObject.selectedIndex].text;
    if (tracerName == null) {
        tracerName = valueObject[valueObject.selectedIndex].value;
    }
    var startIndex = tracerName.indexOf(']');
    var service_id = tracerName.substring(startIndex + 1, tracerName.indexOf('#'));
    var opStartIndex = tracerName.indexOf('#');
    var operation_name = tracerName.substring(opStartIndex + 1, tracerName.indexOf('<'));
    var msStartIndex = tracerName.indexOf('<');
    var message_sequence = tracerName.substring(msStartIndex + 1, tracerName.indexOf('>'));

    var body_xml = '<req:getMessageRequest xmlns:req="http://tracer.service.admin.wsas.wso2.org">\n' +
                   '<serviceId>' + service_id + '</serviceId>\n' +
                   '<operationName>' + operation_name + '</operationName>\n' +
                   '<messageSequence>' + message_sequence + '</messageSequence>\n' +
                   '</req:getMessageRequest>\n';

    var callURL = serverURL + "/" + "TracerService" ;
    send("getMessage", body_xml, "", callURL, "", false, loadTracerTextBoxes);
}

function clearTracer(){
    document.getElementById('txtAreaSend').value = "";
    document.getElementById('txtAreaReceive').value = "";
    document.getElementById('soapTracerContentDiv').style.display = 'none';
    if (monitoringStatus == 'OFF') {
        document.getElementById('soapTracerNoMessagesDiv').style.display = 'none';
        document.getElementById('soapTracerTurnedOffDiv').style.display = '';
    } else {
        document.getElementById('soapTracerTurnedOffDiv').style.display = 'none';
        document.getElementById('soapTracerNoMessagesDiv').style.display = '';
    }
}

function loadTracerTextBoxes() {
    if (!onError()) {
        return;
    }
    var txtAreaSend = document.getElementById('txtAreaSend');
    var txtAreaRecieve = document.getElementById('txtAreaReceive');
    var data = getBody(xhReq.responseXML);

    var retsSMObj = data.getElementsByTagName("sentMessage")[0].firstChild;

    var retsRMObj = data.getElementsByTagName("receivedMessage")[0].firstChild;

    if (retsSMObj != null) {
        txtAreaSend.value = retsSMObj.nodeValue;
    } else {
        txtAreaSend.value = "No SOAP Message Present";
    }

    if (retsRMObj != null) {
        txtAreaRecieve.value = retsRMObj.nodeValue;
    } else {
        txtAreaRecieve.value = "No SOAP Message Present";
    }
}

function shrinkRequestTextBox() {

    var txtAreaSend = document.getElementById('txtAreaSend');
    var txtAreaRecieve = document.getElementById('txtAreaReceive');

    if (!txtAreaReceiveBoolean) {
        txtAreaReceiveBoolean = true;
        document.getElementById('tracer_zoom_out_link_1').className = "zoom_in_link";
        document.getElementById('tracer_zoom_out_link_2').className = "zoom_out_link";
        txtAreaSend.rows = '30';
        txtAreaRecieve.rows = '1';
    } else {
        txtAreaReceiveBoolean = false;
        document.getElementById('tracer_zoom_out_link_2').className = "zoom_out_link";
        document.getElementById('tracer_zoom_out_link_1').className = "zoom_out_link";
        txtAreaRecieve.rows = '15';
        txtAreaSend.rows = '15';
    }
}

function shrinkResponseTextBox() {
    var txtAreaSend = document.getElementById('txtAreaSend');
    var txtAreaRecieve = document.getElementById('txtAreaReceive');
    if (!txtAreaSendBoolean) {
        txtAreaSendBoolean = true;
        document.getElementById('tracer_zoom_out_link_2').className = "zoom_in_link";
        document.getElementById('tracer_zoom_out_link_1').className = "zoom_out_link";
        txtAreaSend.rows = '1';
        txtAreaRecieve.rows = '30';
    } else {
        txtAreaSendBoolean = false;
        document.getElementById('tracer_zoom_out_link_1').className = "zoom_out_link";
        document.getElementById('tracer_zoom_out_link_2').className = "zoom_out_link";
        txtAreaSend.rows = '15';
        txtAreaRecieve.rows = '15';
    }
}

function loadTracerListComboBox(_updateDiv) {
    m_updateDiv = _updateDiv;

    var body_xml = '<req:getLastMessagesRequest xmlns:req="http://tracer.service.admin.wsas.wso2.org">\n' +
                   '<messages>30</messages>\n' +
                   '</req:getLastMessagesRequest>\n';

    var callURL = serverURL + "/" + "TracerService" ;
    send("getLastMessages", body_xml, "", callURL, "", false, loadTracerListCallback);
}

//load user list callback.
function loadTracerListCallback() {
    if (!onError()) {
        return;
    }
//    var comboToLoad = document.getElementById('tracerSelectBox');
    var comboToLoad = m_updateDiv;
//    comboToLoad.style.display = 'none';
    var data = getBody(xhReq.responseXML);
    var rets = data.getElementsByTagName("messages");
    var len = rets.length;
    var count;

    var veryfirst = "";
    var comboCount = 0;
    var noMessagesFound = false;
    for (count = (len - 1); count >= 0; count--) {

        if (rets[count].getElementsByTagName("serviceId")[0].firstChild != null) {
            document.getElementById('soapTracerContentDiv').style.display = '';
            document.getElementById('soapTracerNoMessagesDiv').style.display = 'none';
            document.getElementById('soapTracerTurnedOffDiv').style.display = 'none';
            var messageNameForListBox = "[" + rets[count].getElementsByTagName("timestamp")[0].firstChild.nodeValue +
                                        "]\t" +

                                        rets[count].getElementsByTagName("serviceId")[0].firstChild.nodeValue +
                                        "#" +
                                        rets[count].getElementsByTagName("operationName")[0].firstChild.nodeValue +
                                        "\t<" +
                                        rets[count].getElementsByTagName("messageSequence")[0].firstChild.nodeValue + ">";


            var messageName = rets[count].getElementsByTagName("serviceId")[0].firstChild.nodeValue +
                              "-" +
                              rets[count].getElementsByTagName("operationName")[0].firstChild.nodeValue +
                              "-" +
                              rets[count].getElementsByTagName("messageSequence")[0].firstChild.nodeValue;

            if (count == (len - 1)) {
                veryfirst = messageName;
            }
        } else {
            noMessagesFound = true;
            clearTracer();
        }
        comboToLoad.options[comboCount] = new Option(messageNameForListBox);
        comboToLoad.options[comboCount].value = messageNameForListBox;
        comboCount ++;
    }
    //populating veryfirst
    if (!noMessagesFound) {
        var tracerName = veryfirst;
        var service_id = tracerName.substring(0, tracerName.indexOf('-'));
        var tracerName_rest = tracerName.substring(tracerName.indexOf('-') +
                                                   1, tracerName.length);
        var operation_name = tracerName_rest.substring(0, tracerName_rest.indexOf('-'));
        var message_sequence = tracerName_rest.substring(tracerName_rest.indexOf('-') +
                                                         1, tracerName_rest.length);
        var body_xml = '<req:getMessageRequest xmlns:req="http://tracer.service.admin.wsas.wso2.org">\n' +
                       '<serviceId>' + service_id + '</serviceId>\n' +
                       '<operationName>' + operation_name +
                       '</operationName>\n' +
                       '<messageSequence>' + message_sequence +
                       '</messageSequence>\n' +
                       '</req:getMessageRequest>\n';
        
        var callURL = serverURL + "/" + "TracerService" ;
        send("getMessage", body_xml, "", callURL, "", false, loadTracerTextBoxes);
    }
}


