<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

   <xsl:template match="ns:getModuleInfoResponse" xmlns:ns="http://org.apache.axis2/xsd">
        <h4><a href="#" onClick="javascript:listModules(); return false;">Modules</a>&#160;&gt;&#160;<xsl:value-of select="return/modulename"/></h4>
        <h2>Module Information</h2>

        <xsl:variable name="active"><xsl:value-of select="return/active"/></xsl:variable>
        <fieldset style="border:none;">
    	<div id="formset">
           <xsl:for-each select="return">
                <table class="semi">
                    <tr>
                        <td><strong>Module ID</strong></td>
                        <td><xsl:value-of select="moduleid"/></td>
                    </tr>
                    <tr>
                        <td><strong>Version</strong></td>
                        <td><xsl:value-of select="moduleversion"/></td>
                    </tr>
                    <tr>
                        <td><strong>Description</strong></td>
                        <td><xsl:value-of select="description"></xsl:value-of></td>
                    </tr>
                    <tr>
                        <td><strong>Globally Engaged?</strong></td>
                        <td>
                           <xsl:choose>
                               <xsl:when test="engaged='true'">
                                    Yes
                               </xsl:when>
                               <xsl:otherwise>
                                    No
                               </xsl:otherwise>
                           </xsl:choose>
                        </td>
                    </tr>
                </table>
            </xsl:for-each>
            <br/><br/>

            <table>
                <tr>
                    <td>
                        <a id="edit_link">
                            <xsl:attribute name="href">#</xsl:attribute>
                            <xsl:attribute name="onClick">javascript:getModuleParametersForConfig('<xsl:value-of select="return/moduleid"/>','<xsl:value-of select="return/moduleversion"/>'); return false;</xsl:attribute>
                            <xsl:text>&#160;&#160;&#160;&#160;&#160;Configure Parameters</xsl:text>
                        </a>
                    </td>
                </tr>
                <tr>
                    <td>
                        <a id="edit_link">
                            <xsl:attribute name="href">#</xsl:attribute>
                            <xsl:attribute name="onClick">javascript:getModulePolicies('<xsl:value-of select="return/moduleid"/>','<xsl:value-of select="return/moduleversion"/>'); return false;</xsl:attribute>
                            <xsl:text>&#160;&#160;&#160;&#160;&#160;Configure Policies</xsl:text>
                        </a>
                    </td>
                </tr>
            </table>
		</div>
        </fieldset>
    </xsl:template>
</xsl:stylesheet>
