<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >
    <!-- Template for configuring module parameters-->
    <xsl:output method="html"/>

    <xsl:template match="ns1:getModuleParametersResponse" xmlns:ns1="http://org.apache.axis2/xsd">
        <fieldset style="border:none;">
            <div id="configureModuleHeader"></div>

        <xsl:choose>
            <xsl:when test="return">
                <div id="moduleConfigUpdate"></div>

                <!-- Div handling starts from here-->
                <div id="formset">
                    <form>
                        <fieldset>
                            <legend>Edit module specific parameters</legend>
                            <xsl:for-each select="return">
                                <div style="clear: both;">
                                    <label style="width: 25%"><xsl:value-of select="parameter/@name"/></label>
                                    <input type="text" size="50">
                                            <xsl:attribute name="size">50</xsl:attribute>
                                            <xsl:attribute name="value"><xsl:value-of select="parameter"/></xsl:attribute>
                                            <xsl:attribute name="id"><xsl:value-of select="generate-id()"/></xsl:attribute>
                                            <xsl:attribute name="tabindex">
                                                <xsl:value-of select="position()"/>
                                            </xsl:attribute>
                                            <xsl:if test="@locked='true'">
                                                <xsl:attribute name="disabled">true</xsl:attribute>
                                            </xsl:if>
                                    </input>
                                </div>
                            </xsl:for-each>
                            <p>&#160;</p>
                            <div class="buttonrow">
                                <!-- update button -->
                                <input type="button" value="update">
                                    <xsl:attribute name="onClick">javascript:
                                        var arrayOfNames=new Array();
                                        var arrayOfValues=new Array();
                                        <xsl:for-each select="return">
                                            arrayOfNames[<xsl:value-of select="position()-1"/>] = '<xsl:value-of select="parameter/@name"/>';
                                            arrayOfValues[<xsl:value-of select="position()-1"/>] = (document.getElementById('<xsl:value-of select="generate-id()"/>').value);
                                        </xsl:for-each>
                                        processModuleConfigUpdate(arrayOfNames,arrayOfValues);
                                        return false;
                                    </xsl:attribute>
                                </input>
                                <input type="button" value="add">
                                    <xsl:attribute name="onClick">javascript:addModuleParameter();return false;</xsl:attribute>
                                </input>
                            </div>

                        </fieldset>
                      </form>
                </div>
            </xsl:when>
            <xsl:otherwise>
                <div id="moduleConfigUpdate"></div>
                <!-- end of link header block -->
                <div id="formset">
                    <form>
                        <fieldset>
                            <legend>Parameters</legend>
                                <p>No Module parameters found.</p>
                                <div>
                                    <!-- add button -->
                                    <input type="button" value="add">
                                        <xsl:attribute name="onClick">javascript:addModuleParameter();return false;</xsl:attribute>
                                    </input>
                                </div>
                        </fieldset>
                    </form>
                </div>
            </xsl:otherwise>
        </xsl:choose>

        </fieldset>
    </xsl:template>
</xsl:stylesheet>
