<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>
    <xsl:template match="*">
        <!--  Link header to be populated by java script -->
        <div id="listOperationParamEditHeader"></div>
        <!-- custom header for message display -->
        <div id="operationConfigUpdate"></div>

        <xsl:choose>
            <xsl:when test="return">
				<div id="formset">
					<form>
						<fieldset>
							<legend>Edit operation specific parameters</legend>
							<xsl:for-each select="return">
								<div style="clear: both;"><label style="width: 25%"><xsl:value-of select="parameter/@name"/></label>
									<input type="text" size="50">
										<xsl:attribute name="value"><xsl:value-of select="parameter"/></xsl:attribute>
										<xsl:attribute name="id"><xsl:value-of select="generate-id()"/></xsl:attribute>
										<xsl:attribute name="tabindex">
											<xsl:value-of select="position()"/>
										</xsl:attribute>
										<xsl:if test="@locked='true'">
											<xsl:attribute name="disabled">true</xsl:attribute>
										</xsl:if>
									</input>
								</div>
							</xsl:for-each>
							<p>&#160;</p>
							<div class="buttonrow">
								<input type="button" value="update">
									<xsl:attribute name="onClick">javascript:
										var arrayOfNames=new Array();
										var arrayOfValues=new Array();
										<xsl:for-each select="return">
											arrayOfNames[<xsl:value-of select="position()-1"/>] = '<xsl:value-of select="parameter/@name"/>';
											arrayOfValues[<xsl:value-of select="position()-1"/>] = (document.getElementById('<xsl:value-of select="generate-id()"/>').value);
										</xsl:for-each>
										processOperationParameterConfigUpdate(arrayOfNames,arrayOfValues);
										return false;
									</xsl:attribute>
								</input>
								<input type="button" value="add">
									<xsl:attribute name="onClick">javascript:addOperationParameter();return false;</xsl:attribute>
								</input>
							</div>
						</fieldset>
					</form>
				</div>
            </xsl:when>
            <xsl:otherwise>
                   <table>
                     <tr>
                         <td>No parameters found.</td>
                     </tr>
                    <tr>
                        <td>
                            <!-- add button -->
                            <input type="button" value="add">
                                <xsl:attribute name="onClick">javascript:addOperationParameter();return false;</xsl:attribute>
                            </input>
                        </td>
                    </tr>
                </table>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>


