<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="ns1:listServiceGroupsResponse" xmlns:ns1="http://org.apache.axis2/xsd">
        <xsl:choose>
            <xsl:when test="return">
                <table class="styled">
                    <thead>
                        <tr>
                            <th>Service Groups</th>
                            <th>Actions</th>
                            <th>Services</th>
                            <th>View</th>
                        </tr>
                    </thead>
                    <tbody>
                        <xsl:for-each select="return">
                            <tr>
                                <td>
                                    <xsl:attribute name="rowspan">
                                        <xsl:value-of select="count(services) + 1"/>
                                    </xsl:attribute>
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onclick">javascript:showServiceGroupInfo('<xsl:value-of select="group_name"/>'); return false;</xsl:attribute>
                                            <xsl:attribute name="title">Show Service Group <xsl:value-of select="group_name"/></xsl:attribute>
                                            <xsl:value-of select="group_name"/> [<xsl:value-of select="group_name"/>.aar]
                                        </a>
                                </td>
                                <td>
                                    <xsl:attribute name="rowspan"><xsl:value-of select="count(services) + 1"/></xsl:attribute>
                                    <nobr>
                                        &#160;&#160;
                                        <a href="#" id="cancel_link">
                                            <xsl:attribute name="onClick">javascript:deleteServiceGroup('<xsl:value-of select="group_name"/>'); return false;</xsl:attribute>
                                            <xsl:attribute name="title">Remove <xsl:value-of select="group_name"/>Service Group</xsl:attribute>
                                            <xsl:attribute name="alt">Remove</xsl:attribute>
                                            &#160;&#160;&#160;&#160;
                                        </a>
                                    </nobr>
                                </td>
                                <td/>
                            </tr>
                            <xsl:variable name="service_context_path"><xsl:value-of select="serviceContextPath"/></xsl:variable>
                            <xsl:for-each select="services">
                                <xsl:sort/>
                                <tr>
                                    <td>
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:listServiceDataRefresh('<xsl:value-of select="."/>'); return false;</xsl:attribute>
                                            <xsl:value-of select="."/>
                                        </a>
                                    </td>
                                    <td style="width: 200px;">
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:openWindowHTTP('<xsl:value-of select="."/>?wsdl');return false;</xsl:attribute>
                                            <xsl:attribute name="target">_blank</xsl:attribute>
                                            <xsl:text>WSDL&#160;1.1</xsl:text>
                                        </a>
                                        <xsl:text>&#160;&#160;</xsl:text>
                                        <!--<a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:openWindowHTTP('<xsl:value-of select="."/>?wsdl2');return false;</xsl:attribute>
                                            <xsl:attribute name="target">_blank</xsl:attribute>
                                            <xsl:text>WSDL&#160;2.0</xsl:text>
                                        </a>
                                        <xsl:text>&#160;&#160;&#160;</xsl:text>-->
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:openWindowHTTP('<xsl:value-of select="."/>?xsd');return false;</xsl:attribute>
                                            <xsl:attribute name="target">_blank</xsl:attribute>
                                            <xsl:text>Schema</xsl:text>
                                        </a>
                                        <xsl:text>&#160;&#160;&#160;</xsl:text>
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:openWindowHTTP('<xsl:value-of select="."/>?policy');return false;</xsl:attribute>
                                            <xsl:attribute name="target">_blank</xsl:attribute>
                                            <xsl:text>Policy</xsl:text>
                                        </a>
                                        <xsl:text>&#160;&#160;&#160;</xsl:text>
                                        <a>
                                            <xsl:attribute name="href">#</xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:openWindowHTTP('<xsl:value-of select="."/>?cert');return false;</xsl:attribute>
                                            <xsl:attribute name="target">_blank</xsl:attribute>
                                            <xsl:text>Certificate</xsl:text>
                                        </a>
                                    </td>
                                </tr>
                            </xsl:for-each>
                        </xsl:for-each>
                    </tbody>
                </table>
            </xsl:when>
            <xsl:otherwise>
                <b>
                    <i>No Active Services</i>
                </b>
            </xsl:otherwise>

        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
