<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>
    <xsl:template match="*">
       <fieldset style="border:none;">
        <h2>SOAP Tracer</h2>
        <div id="formset">
            <form>
				<fieldset>
					<legend>SOAP Tracer</legend>

                    <xsl:call-template name="starter"/>
                    <xsl:call-template name="soapTracerContentDivTemplate"/>
                    <xsl:call-template name="extraSOAPTracerSettingTemplate"/>
                    <xsl:call-template name="extraSOAPTracerSettingTemplate"/>

                </fieldset>
			</form>
        </div>
        </fieldset>
    </xsl:template>

    <xsl:template name="starter">
        <div id="soapTracingDiv">

            <label>SOAP Tracing</label>
            <select tabindex="1">
                <xsl:attribute name="id">monitorSettingCombo</xsl:attribute>
                <xsl:attribute name="onchange">javascript:setMonitoring(this);return false;</xsl:attribute>
            </select>
        </div>
    </xsl:template>

    <xsl:template name="soapTracerContentDivTemplate">
        <div id="soapTracerContentDiv" style="display:none;">
            <div>
                <b>Select SOAP Message To View</b>
            </div>
            <div>
                <select id="tracerSelectBox" tabindex="2">
                    <xsl:attribute name="onChange">javascript:traceMessage(document.getElementById('tracerSelectBox')); return false;</xsl:attribute>
                    <xsl:attribute name="size">5</xsl:attribute>
                    <xsl:attribute name="multiple">false</xsl:attribute>
                </select>
            </div>

            <div>
                    <table>
                        <tr>
                            <td>
                                 <div>
                                    <b>SOAP Message - Request</b>
                                 </div>
                                <div>
                                    <textarea id="txtAreaReceive" cols="80" rows="15"></textarea>
                                </div>
                            </td>
                            <td>
                                <nobr>
                                    &#160;&#160;
                                    <a href="#" id="tracer_zoom_out_link_1" class="zoom_out_link">
                                        <xsl:attribute name="onClick">javascript:shrinkRequestTextBox();return false;</xsl:attribute>
                                        <xsl:attribute name="title">Shrink Request TextBox</xsl:attribute>
                                        <xsl:attribute name="alt">Remove</xsl:attribute>
                                        &#160;&#160;&#160;&#160;
                                    </a>
                                </nobr>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div>
                                    <b>SOAP Message - Response</b>
                                </div>
                                <div>
                                    <textarea id="txtAreaSend" cols="80" rows="15"></textarea>
                                </div>
                            </td>
                            <td>
                                <nobr>
                                    &#160;&#160;
                                    <a href="#" id="tracer_zoom_out_link_2" class="zoom_out_link">
                                        <xsl:attribute name="onClick">javascript:shrinkResponseTextBox();return false;</xsl:attribute>
                                        <xsl:attribute name="title">Shrink Response TextBox</xsl:attribute>
                                        <xsl:attribute name="alt">Remove</xsl:attribute>
                                        &#160;&#160;&#160;&#160;
                                    </a>
                                </nobr>
                            </td>
                        </tr>
                    </table>
                </div>
        </div>

    </xsl:template>

    <xsl:template name="extraSOAPTracerSettingTemplate">
        <div id="soapTracerNoMessagesDiv" style="display:none;">
            <table>
                <tr>
                    <td>&#160;&#160;&#160;&#160;</td>
                    <td>
                        <h4>No SOAP messages in the Tracer's buffer.</h4>
                    </td>
                </tr>
            </table>
        </div>
        <div id="soapTracerTurnedOffDiv" style="display:none;">
            <table>
                <tr>
                    <td>&#160;&#160;&#160;&#160;</td>
                    <td>
                        <h4>SOAP Tracer has been turned off.</h4>
                    </td>
                </tr>
            </table>
        </div>
    </xsl:template>

</xsl:stylesheet>
