var chadURL;
var chadServiceURL;
var _url;
var chadXhReq;

/*Adminstration check varaiable*/

var isAuthorized = false;

var adminUserInUse;

var currentLoginAdmin;

var currentPollId;

/*
    ****************************************
            Setting for ServiceURL
    ****************************************
    Thus can be found in the WSO2WSAS_HOME/conf/axis2.xml. See the relevant segment
    in this file below

    <!-- setting contextPath and servicePath-->
    <parameter name="contextRoot" locked="false">/</parameter>
    <parameter name="servicePath" locked="false">soap</parameter>

*/
var CONTEXT_PATH_DEFAULT = "/";
var SERVICE_PATH_DEFAULT = "soap";

var contextPath = CONTEXT_PATH_DEFAULT;
var servicePath = SERVICE_PATH_DEFAULT;

var serviceURL =
        (contextPath != "/")? ( contextPath + "/" + servicePath +"/") : "/" + servicePath + "/";

// This version assumes that the communication between the server and the client happens in an unsecure manner.
function sendUnsecured(operationName, body_xml, xslFileName, callURL, objDiv, callBack) {
    chadXhReq = createXMLHttpRequest();
    if (callBack != null){
        chadXhReq.onreadystatechange = callBack;
    } else {
        chadXhReq.onreadystatechange = function() {
            if (!non_auth_check_error()) {
                return;
            }
//            alert("XML = " + (new XMLSerializer()).serializeToString(chadXhReq.responseXML));
            //alert("Response" + (new XMLSerializer()).serializeToString(getBody(xhReq.responseXML)));
            if (xslFileName != "" && objDiv != null){
                var data = getBody(chadXhReq.responseXML);
//                alert("Response" + xmlSerializerToString(data));
                processXML(data, xslFileName, objDiv);
                showOnlyOneMain(objDiv);
            }
        };
    }

    try {
        chadXhReq.open("POST", callURL, true);
    } catch(e){

        alertWarning("Error while opening connection. ERROR message = " + e.message);
        return false;
    }
    chadXhReq.setRequestHeader('Content-Type',  "text/xml");
    chadXhReq.setRequestHeader("SOAPAction", operationName);

    var xml_to_send = '<?xml version="1.0" encoding="UTF-8"?>' +
                      ' <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">' +
                      ' <soapenv:Header xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing">';
    xml_to_send +=' <wsa:To>' + callURL + '</wsa:To>' +
    			  ' <wsa:Action>' + operationName + '</wsa:Action>' +
                  ' <wsa:ReplyTo>' +
                  ' <wsa:Address>http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous</wsa:Address>' +
                  ' </wsa:ReplyTo>' +
                  ' <wsa:MessageID>uuid:BABE23A9BE85EA7AE011327368520801</wsa:MessageID>' +
                  ' </soapenv:Header>' +
                  ' <soapenv:Body>'+ body_xml +
                  ' </soapenv:Body>' +
                  ' </soapenv:Envelope>';

    chadXhReq.send(xml_to_send);

}

function onErrorUnsecured(){
    if (chadXhReq.readyState != 4)  { return false ; }
    var wso2wsasError = "";
    var wso2wsasErrorMessage = "";
    try {
        if (chadXhReq.status != 200 && chadXhReq.status != 202)  {
//        alert((new XMLSerializer()).serializeToString(chadXhReq.responseXML));
            if (chadXhReq.responseXML != null){
				if (chadXhReq.responseXML.getElementsByTagName("Reason")[0] != null) {
					wso2wsasErrorMessage = chadXhReq.responseXML.getElementsByTagName("Reason")[0].childNodes[0].nodeValue;
				} else {
					if (chadXhReq.responseXML.getElementsByTagName("faultstring")[0] != null) {
						wso2wsasErrorMessage = chadXhReq.responseXML.getElementsByTagName("faultstring")[0].childNodes[0].nodeValue;
					}
				}
                var errNode = getExceptionNode(chadXhReq.responseXML);
                if (errNode != null){
                	try {
                		wso2wsasError = (new XMLSerializer()).serializeToString(errNode);
                	} catch (e) {
                		try{
                			wso2wsasError = errNode.xml;
                		} catch(e) {
	                	    wso2wsasErrorMessage = "The Chad application encountered an error and the browser you are using does not suport the error reporting code. \n" +
    	            	    					"Logging in again should fix this, since the most common error is the a session time out error.";
        	            	alertWarning(wso2wsasErrorMessage);
                	    	return false;
                	    }
                	}
                    /*if (wso2wsasError.indexOf("Invalid Service Group Id") != -1){
                        alertMessage("Your session has expired please login.");
                        logoutVisual();
                        return false;
                    }*/
                } else {
                    wso2wsasErrorMessage =
                    "\n The Chad application encountered an unknown error.";
                }
            } else {
//                logoutVisual();
                alertWarning("Your session has expired please login");
                return false;
            }
            alertWarning(wso2wsasErrorMessage);
//            alert((new XMLSerializer()).serializeToString(errNode))
            return false;
        }
    } catch(e){
    	if (!restarting_the_server){
    		if (e.message.indexOf("NS_ERROR_NOT_AVAILABLE")>0){
				alertWarning("Could not connect to the server. Please try again in a moment.");
				return false;
			} else {
				alertWarning("An unknown error occured. In line number " + e.lineNumber + " the error message was " + e.message);
				return false;
    	   	}
    	} else {
            alertMessage("The server is being restarted. <br/> Please login in a few seconds.");
    		restarting_the_server = false;
    	}
    }
    return true;
}



function initChad(){
	chadURL = locationString.substring(0, locationString.lastIndexOf('/'));

	if (chadURL.lastIndexOf('wservices') > 0) {
			chadServiceURL = chadURL.substring(0, chadURL.lastIndexOf('wservices') - 1);
			_url =    chadServiceURL;
	} else {
		chadServiceURL = chadURL.substring(0, chadURL.lastIndexOf('Chad') - 1);
		   _url =    chadServiceURL;
	}
	if (wso2wsas_war_name != "") {
		chadServiceURL += "/" + wso2wsas_war_name;
	}

    chadServiceURL += serviceURL + "Chad";

    if (servicePath == "" || servicePath == null ) {
        alertWarning("Service path is not specified.\n"+
                     "Please specify the 'servicePath' variable in 'main.js' to proceed");
        return false;
    }

//    initialize();
    URL = _url + "/wservices/Chad";

    initLogin();

    listAllPolls();
}

function initDhtmlHistory() {
    /*intitialize the hashing*/
    runPoleHash = true;
    // initialize our DHTML history
	dhtmlHistory.initialize();
	// subscribe to DHTML history change
	// events
    historyStorage.reset();
    dhtmlHistory.addListener(handleHistoryChangeChad);

}

/** A function that is called whenever the user
    presses the back or forward buttons. This
    function will be passed the newLocation,
    as well as any history data we associated
    with the location. */
function handleHistoryChangeChad(newLocation,
                             historyData) {
    var actDivName = newLocation.substring(3, newLocation.length);
    // This is done to stop the screen from jumping about.
    eval("showOnlyOneMain(document.getElementById('" + actDivName + "'), true)");
    // lastHash from mf_ui; main.js
    lastHash = newLocation;
}


function listAllPolls() {

    var body_xml = '<req:listPollsMessage xmlns:req="http://www.wso2.org/types"/>';

    sendUnsecured("listPolls", body_xml, "", chadServiceURL, "",listPollsAllCallback);

}

function listPollsAllCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("list_polls_all.xsl",document.getElementById("divChadListPolls"));

}

function listAllPollsAdmin() {
   var body_xml = '<req:listPollsMessage xmlns:req="http://www.wso2.org/types"/>';

    sendUnsecured("listPolls", body_xml, "", chadServiceURL, "",listAllPollsAdminCallback);
}

function listAllPollsAdminCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("list_polls_admin.xsl",document.getElementById("divAllPolls"));
}

function listActivePollsAdmin() {
    var body_xml = '<req:listPollsMessage xmlns:req="http://www.wso2.org/types"/>';
    sendUnsecured("listPolls", body_xml, "", chadServiceURL, "",listActivePollsAdminCallback);
}

function listActivePollsAdminCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("list_active_polls_admin.xsl",document.getElementById("divChadListPolls"));
}

function listActivePolls() {
    var body_xml = '<req:listPollsMessage xmlns:req="http://www.wso2.org/types"/>';
    sendUnsecured("listPolls", body_xml, "", chadServiceURL, "",listActivePollsCallback);
}

function listActivePollsCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("list_active_polls.xsl",document.getElementById("divChadListPolls"));
}

function initLogin() {
    /*
    Login settings
    */
    var loginString = "<a href=\"#\" onclick=\"javascript:fireLogin();return false;\">Adminstrator Login</a>";
    document.getElementById("meta").innerHTML = loginString;
    document.getElementById('menuChad').style.display = 'none';
    document.getElementById('menuChad1').style.display = 'inline';
}

function showChadLogout() {
    /*logout setting */
    var loginString = "<a href=\"#\" onclick=\"javascript:fireLogin();return false;\">Adminstrator Login</a>";
    document.getElementById("meta").innerHTML = loginString;
    document.getElementById('menuChad').style.display = 'none';
    document.getElementById('menuChad1').style.display = 'inline';

    /*Logout SOAP Call */
    var body_xml = '<req:logout xmlns:req="http://www.wso2.org/types"/>';

    sendUnsecured("logout", body_xml, "", chadServiceURL, "",showChadLogoutCallback);

}

function showChadLogoutCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    isAuthorized = false;
    runPoleHash = false;
    historyStorage.reset();
    listAllPolls();
}

function showChadLogin() {
    /*
    Login settings
    */
    var loginString =
            "Signed in as &nbsp;"+getCurrentLoginAdmin()+"&nbsp;|&nbsp;<a href=\"#\" onclick=\"javascript:showChadLogout();return false;\">Sign Out</a>";
    document.getElementById("meta").innerHTML = loginString;

    document.getElementById('menuChad').style.display = 'inline';
    document.getElementById('menuChad1').style.display = 'none';

    /*Cleraring the Password fileld*/
    document.chadFormLogin.txtPassword.value = '';
}

function fireLogin() {
    var obj = document.getElementById('divLogincontainer');
    showOnlyOneMain(obj,true);
}

function chadLogin(userNameValue,passwordValue) {

    currentLoginAdmin = userNameValue;

    var body_xml = '<req:login xmlns:req="http://www.wso2.org/types">' +
                   '<req:username><![CDATA['+userNameValue+']]></req:username>'+
                   '<req:password><![CDATA['+passwordValue+']]></req:password>'+
                   '</req:login>';

    sendUnsecured("login", body_xml, "", chadServiceURL, "", chadLoginCallback);

}

function chadLoginCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    if (chadXhReq.responseXML.getElementsByTagName("return")[0] != null){
        if (chadXhReq.responseXML.getElementsByTagName("return")[0].firstChild.nodeValue == "true"){
//    		alertMessage("Login Successful");
            isAuthorized = true;
            showChadLogin();
            // place to init the history
           initDhtmlHistory();
           listActivePollsAdmin();
        } else {
	       alertWarning("Login failed!");
           isAuthorized = false;
           listAllPolls();
        }
	}


}

function showActivePolls() {
    if (isAuthorized) {
        listActivePollsAdmin();
    } else {
        listAllPolls();
    }
}

//@private helper method
function chadCallbackHelper(xsltFile, objDiv, doNotLoadDiv) {
    var xml = getBody(chadXhReq.responseXML);
    processXML(xml, xsltFile, objDiv);
	if (!doNotLoadDiv){
		showOnlyOneMain(objDiv);
	}

}

function listStartedPolls() {
    var body_xml = '<req:getStartedPolls xmlns:req="http://www.wso2.org/types"/>';
    sendUnsecured("getStartedPolls", body_xml, "", chadServiceURL, "", listStartedPollsCallback);

}

function listStartedPollsCallback() {
   if (!onErrorUnsecured()) {
		return;
	}
    chadCallbackHelper("list_polls_admin.xsl",document.getElementById("divChadStartedPolls"));
}

function listStoppedPolls() {

    var body_xml = '<req:getStoppedPolls xmlns:req="http://www.wso2.org/types"/>';

    sendUnsecured("getStoppedPolls", body_xml, "", chadServiceURL, "",listStoppedPollsPollsCallback);

}

function listStoppedPollsPollsCallback() {
    if (!onErrorUnsecured()) {
		return;
	}
    chadCallbackHelper("list_stopped_polls.xsl",document.getElementById("divChadStopedPolls"));
}



function createPollSave() {

    if (!createPollSaveValidator()) {
        return false;

    }
    var body_xml = '<req:createPoll xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:title><![CDATA[' + document.getElementById("txtPollTitle").value + ']]></req:title>\n' +
                   '<req:description><![CDATA[' + document.getElementById("txtPollDescription").value + ']]></req:description>\n' +
                   '<req:isSingleVote>' + document.getElementById("cmbPollSingleVote").value + '</req:isSingleVote>\n';
	var inputs = document.getElementById("frmCreatePoll").getElementsByTagName("input");
	var count;
    for (count=0; count < inputs.length; count++){
		if (inputs[count].attributes.getNamedItem("name") != null){
			if (inputs[count].attributes.getNamedItem("name").nodeValue == "txtPollChoices"){
				body_xml += '<req:choices>' + inputs[count].value + '</req:choices>\n';
			}
		}
	}
	body_xml += '</req:createPoll>\n';
    sendUnsecured("createPoll", body_xml, "", chadServiceURL, "", createPollSaveCallback);
    return false;
}

//@private validator
function createPollSaveValidator() {

    var titleObj = document.getElementById('txtPollTitle');

    var titleObjValue = "";
    titleObjValue = titleObj.value;

    if (trim(titleObjValue) == "" || titleObjValue == null ) {
        alertWarning("Please enter a valid title.");
        return false;

    }

    var choicesObj = document.getElementsByName('txtPollChoices');
    var numOfValidChoices = 0;
    for(var i=0; i < choicesObj.length; i++){
        if(trim(choicesObj[i].value) != ""){
            numOfValidChoices ++;
        }
    }
    if(numOfValidChoices < 2){
        alertWarning("A valid poll should contain more than one choice. <br/>Please add at least two choices.");
        return false;
    }
    return true;
}

function createPollSaveCallback() {
	if (!onErrorUnsecured()) {
		return;
	}
	alertMessage("Poll created successfully");
	listActivePollsAdmin();
}

function addNewChoice(){
	var objDiv = document.getElementById("choicesDiv");
	var blankLabelElem = document.createElement('label');
	blankLabelElem.innerHTML = "&nbsp;";
	var elem = document.createElement('input');
	var brElem = document.createElement('br');
	var nameAttr = document.createAttribute('name');
	nameAttr.value = "txtPollChoices";
	var sizeAttr = document.createAttribute('size');
	sizeAttr.value = "50";
	var typeAttr = document.createAttribute('type');
	typeAttr.value = "text";
	elem.attributes.setNamedItem(nameAttr);
	elem.attributes.setNamedItem(sizeAttr);
	elem.attributes.setNamedItem(typeAttr);
	objDiv.appendChild(brElem);
	objDiv.appendChild(blankLabelElem);
	objDiv.appendChild(elem);
}

function startPoll(pollId){
    var body_xml = '<req:startPollMessage xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n' +
                   '</req:startPollMessage>\n';
    sendUnsecured("startPoll", body_xml, "", chadServiceURL, "", startPollCallback);
}

function startPollCallback(){
    if (!onErrorUnsecured()) {
        return;
    }
	alertMessage("Poll started successfully.");
	listActivePollsAdmin();
}


function stopPoll(pollId){
    var body_xml = '<req:stopPollMessage xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n' +
                   '</req:stopPollMessage>\n';
    sendUnsecured("stopPoll", body_xml, "", chadServiceURL, "", stopPollCallback);
}

function stopPollCallback(){
    if (!onErrorUnsecured()) {
        return;
    }
	alertMessage("Poll stopped successfully.");
	listActivePollsAdmin();
}

function createPoll(){

    /*
    CreatePoll with xsl
    */

    var tmpTransformationNode;

    if (window.XMLHttpRequest && !isIE()) {
        tmpTransformationNode =
        document.implementation.createDocument("", "createPoll", null);
    } else if (window.ActiveXObject) {
        tmpTransformationNode = new ActiveXObject("Microsoft.XmlDom");
        var sXml = "<createPoll></createPoll>";
        tmpTransformationNode.loadXML(sXml);
    }
    var objDiv = document.getElementById("divCreatPoll");
    processXML(tmpTransformationNode, "create_poll.xsl", objDiv);
    showOnlyOneMain(objDiv);
}

function showVoteScreen(pollId){

    currentPollId = pollId;

    var body_xml = '<req:getResultMessage xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n' +
                   '</req:getResultMessage>\n';
    sendUnsecured("getResult", body_xml, "", chadServiceURL, "",showVoteScreenCallback);
}

function showVoteScreenCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("vote.xsl",document.getElementById("divVoteForPoll"));
}


function viewPollDetails(pollId){
    var body_xml = '<req:getResultMessage xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n' +
                   '</req:getResultMessage>\n';
    sendUnsecured("getResult", body_xml, "", chadServiceURL, "",viewPollDetailsCallback);
}

function viewPollDetailsForVoted(pollId) {
    var body_xml = '<req:getResultMessage xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n' +
                   '</req:getResultMessage>\n';
    sendUnsecured("getResult", body_xml, "", chadServiceURL, "",viewPollDetailsForVotedCallback);
}

function viewPollDetailsForVotedCallback() {

    if (!onErrorUnsecured()) {
        return;
    }

    chadCallbackHelper("results.xsl",document.getElementById("divPollDetails"));

    // filling the placeholding div named pollProgressingBarId with proper values
    // Dom manupiulation
    var xml = getBody(chadXhReq.responseXML);

    viewPollDetailsUtil(xml);

    var voteResultsDivObj =  document.getElementById('voteResultsDivId');
    voteResultsDivObj.innerHTML =
            '<label><nobr><strong>We have already received a vote for this poll from your IP address.</nobr>'+
            '<nobr> Hence you are not eligible for voting.</strong></nobr></label>';;
}


function viewPollDetailsCallback() {
   if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("results.xsl",document.getElementById("divPollDetails"));

    // filling the placeholding div named pollProgressingBarId with proper values
    // Dom manupiulation
    var xml = getBody(chadXhReq.responseXML);

    viewPollDetailsUtil(xml);
}

//@private Util function
function viewPollDetailsUtil(xml) {

    var choicesObjects = document.getElementsByName('pollProgressingBarId');

    var votePercentageObjects = xml.getElementsByTagName('votePercentage');

    // in all occasions choicesObjects == votePercentageObjects

    for ( var i = 0 ; i < choicesObjects.length; i++) {

        var valueOfVotePercentage = votePercentageObjects[i].firstChild.nodeValue;
        var txt = progressBarDivObj('predone' + i);

        choicesObjects[i].innerHTML = txt;
        incrCount(valueOfVotePercentage,'predone' + i);

    }

}


function vote(pollId){
    var body_xml = '<req:vote xmlns:req="http://www.wso2.org/types">\n' +
                   '<req:pollID>' + pollId + '</req:pollID>\n';
	var choicesSelected = document.getElementsByName("selectBoxForVotes");
	var count;
	var currentChoice;
	for (count = 0; count < choicesSelected.length;count++){
		currentChoice = choicesSelected[count];
//		alert(currentChoice.checked + "   " + count + currentChoice.id);
		if (currentChoice.checked){
			body_xml += '<req:choices>' + currentChoice.id + '</req:choices>\n';
		}
	}

	body_xml += '</req:vote>\n';
//    alert(body_xml);
    sendUnsecured("vote", body_xml, "", chadServiceURL, "", voteCallback);
}

function voteCallback(){
    if (!onErrorUnsecured()) {
        return;
    }
    if (chadXhReq.responseXML.getElementsByTagName("return")[0] != null){
        if (chadXhReq.responseXML.getElementsByTagName("return")[0].firstChild.nodeValue == "Vote successful"){
    		alertMessage("Your vote was successfully registered.");
		} else {
	    	alertWarning(chadXhReq.responseXML.getElementsByTagName("return")[0].firstChild.nodeValue);
	    }
	}
    if (isAuthorized) {
        listActivePollsAdmin();
    } else {
        listActivePolls();
    }
}


function showAdminstrators() {
   var body_xml = '<req:listAdminUsers xmlns:req="http://www.wso2.org/types"/>';
   sendUnsecured("listAdminUsers", body_xml, "", chadServiceURL, "", listAdminUsersCallback);
}

function listAdminUsersCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    chadCallbackHelper("administrators.xsl",document.getElementById("divAdminstrators"));
}

function addAdminUser(userNameObj,passwordObj,rePasswordObj)  {

    var userNameValue = userNameObj.value;
    var passwordValue = passwordObj.value;
    var rePasswordValue = rePasswordObj.value;

    if (!validateAddAdminUser(userNameValue,passwordValue,rePasswordValue)) {
        return false;
    }
    var body_xml = '<req:addAdminUser xmlns:req="http://www.wso2.org/types">' +
                   '<username><![CDATA['+userNameValue+']]></username>'+
                   '<password><![CDATA['+passwordValue+']]></password>'+
                   '</req:addAdminUser>';

    sendUnsecured("addAdminUser", body_xml, "", chadServiceURL, "", addAdminUserCallback);
    return false;

}

function validateAddAdminUser(userNameValue,passwordValue,rePasswordValue) {
    if (userNameValue == null || trim(userNameValue) == "" ) {
        alertWarning("Please enter the username.");
        return false;
    }

    if (passwordValue == null || passwordValue == "" ) {
        alertWarning("Please enter the password.");
        return false;
    }

    if (rePasswordValue == null || rePasswordValue == "") {
        alertWarning("Please re-enter the password.");
        return false;
    }

    if (passwordValue != rePasswordValue) {
        alertWarning("The password and the re-entered password do not match.");
        return false;
    }
    return true;
}

function addAdminUserCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    alertMessage("New administration account successfully created.");
    showAdminstrators();
}

function deleteAdminUser(adminUserName) {
    if (adminUserName == "admin") {
        alertWarning("You are not permitted to delete the default adminstrator 'admin'");
        return false;
    }

    var boolConfirm = confirm("Do you want to permanently delete Administrator account '" +
                              adminUserName+"?'");

    if (!boolConfirm) {
        return false;
    }

    var body_xml = '<req:deleteAdminUser xmlns:req="http://www.wso2.org/types">' +
                   '<username><![CDATA['+adminUserName+']]></username>'+
                   '</req:deleteAdminUser>';

    sendUnsecured("deleteAdminUser", body_xml, "", chadServiceURL, "", deleteAdminUserCallback);

}

function deleteAdminUserCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    alertMessage("Administrator account successfully removed.");
    showAdminstrators();
}

function changePassword(password, rePassword,oldPassword) {
    if(!changePasswordValidator(password, rePassword,oldPassword)) {
        return false;
    }
    var body_xml = '<req:changePassword xmlns:req="http://www.wso2.org/types">' +
                   '<username><![CDATA['+getAdminUserInUse()+']]></username>'+
                   '<oldPassword><![CDATA['+oldPassword+']]></oldPassword>'+
                   '<newPassword><![CDATA['+password+']]></newPassword>'+
                   '</req:changePassword>';

    sendUnsecured("changePassword", body_xml, "", chadServiceURL, "", changePasswordCallback);
    return false;

}

function changePasswordCallback() {
   if (!onErrorUnsecured()) {
        return;
    }
    alertMessage("Administrator password successfully changed.");
    showAdminstrators();
}

function changePasswordValidator(password, rePassword, oldPassword) {
    if (password == null || trim(password) == "" ) {
        alertWarning("Please enter the new password.");
        return false;
    }

    if (rePassword == null || rePassword == "" ) {
        alertWarning("Please re-enter the password.");
        return false;
    }

    if (oldPassword == null || oldPassword == "") {
        alertWarning("Please enter the old password.");
        return false;
    }

    if (password != rePassword) {
        alertWarning("The new password and the re-entered password do not match.");
        return false;
    }
    return true;

}

function editAdminProperties(adminUserName) {
    adminUserInUse = adminUserName;

    var tmpTransformationNode;

    if (window.XMLHttpRequest && !isIE()) {
        tmpTransformationNode =
        document.implementation.createDocument("", "editAdminProperties", null);
    } else if (window.ActiveXObject) {
        tmpTransformationNode = new ActiveXObject("Microsoft.XmlDom");
        var sXml = "<editAdminProperties></editAdminProperties>";
        tmpTransformationNode.loadXML(sXml);
    }
    var objDiv = document.getElementById("divEditAdminProps");
    processXML(tmpTransformationNode, "administrators.xsl", objDiv);
    showOnlyOneMain(objDiv);
}

function eligibleForVoting(pollId) {
    currentPollId = pollId;

    var body_xml = '<req:eligibleForVoting xmlns:req="http://www.wso2.org/types">\n' +
                   '<pollId>' + pollId + '</pollId>\n' +
                   '</req:eligibleForVoting>\n';
    sendUnsecured("isEligibleForVoting", body_xml, "", chadServiceURL, "",eligibleForVotingCallback);


}

function eligibleForVotingCallback() {
    if (!onErrorUnsecured()) {
        return;
    }
    if (chadXhReq.responseXML.getElementsByTagName("return")[0] != null){
        if (chadXhReq.responseXML.getElementsByTagName("return")[0].firstChild.nodeValue == "true"){
           // eligible for voting
            showVoteScreen(getCurrentPollId());
        } else {
	       // this ip has already been used for voting.
           viewPollDetailsForVoted(getCurrentPollId());
        }
	}


}

function getAdminUserInUse() {
    return adminUserInUse;
}

function getCurrentLoginAdmin() {
    return currentLoginAdmin;
}

function getCurrentPollId() {
    return currentPollId;
}




