<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="*">
        <h4><a href="#" onClick="javascript:showActivePolls(); return false;">Active Polls</a>&#160;&gt;&#160;Vote</h4>
        <h2>Vote</h2>
        <div id="formset">
			<form id="frmVoteForPoll">
				<fieldset>
					<xsl:for-each select="return">
						<xsl:variable name="isSingleVote">
							<xsl:value-of select="singleVote"/>
						</xsl:variable>

                        <xsl:variable name="orderedChoicesCount" select="count(orderedChoices)" />

                        <xsl:if test="$isSingleVote = 'true'">
                             <legend>Select a choice and press the 'Vote' button</legend>
                        </xsl:if>
                        <xsl:if test="$isSingleVote = 'false'">
                            <legend>Select choice(s) and press the 'Vote' button</legend>
                        </xsl:if>

                        <div>
                            <table class="semi">
                                <tr>
                                    <td><strong>Poll Title</strong></td>
                                    <td><xsl:value-of select="pollTitle"/></td>
                                </tr>
                                 <tr>
                                    <td><strong>Description</strong></td>
                                    <td><xsl:value-of select="pollDescription"/></td>
                                </tr>
                                <tr>
                                    <td>
                                        <strong>Choice</strong>
                                    </td>
                                        <xsl:for-each select="orderedChoices">
                                            <tr>
                                                <td>
                                                    <div>
                                                        <label><xsl:value-of select="choiceName"/></label>
                                                        <input>
                                                            <xsl:attribute name="id"><xsl:value-of select="choiceName"/></xsl:attribute>
                                                            <xsl:attribute name="name">selectBoxForVotes</xsl:attribute>
                                                            <xsl:if test="$isSingleVote = 'true'">
                                                                <xsl:attribute name="type">radio</xsl:attribute>
                                                            </xsl:if>
                                                            <xsl:if test="$isSingleVote = 'false'">
                                                                <xsl:attribute name="type">checkbox</xsl:attribute>
                                                            </xsl:if>
                                                        </input>
                                                    </div>
                                                </td>
                                            </tr>
                                       </xsl:for-each>
                                 </tr>
                            </table>
                        </div>

						<div class="buttonrow">
							<input type="button" value="Vote">
								<xsl:attribute name="onclick">javascript:vote('<xsl:value-of select="pollId"/>');</xsl:attribute>
							</input>
						</div>
					</xsl:for-each>
				</fieldset>
			</form>
      	</div>
    </xsl:template>
</xsl:stylesheet>
